"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("react");
var mapboxgl_1 = require("../utils/mapboxgl");
var use_control_1 = require("./use-control");
var GeolocateControl = (0, react_1.forwardRef)(function (props, ref) {
    var thisRef = (0, react_1.useRef)({ props: props });
    var ctrl = (0, use_control_1.default)(function () {
        var gc = new mapboxgl_1.default.GeolocateControl(props);
        gc.on('geolocate', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onGeolocate) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        gc.on('error', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onError) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        gc.on('outofmaxbounds', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onOutOfMaxBounds) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        gc.on('trackuserlocationstart', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onTrackUserLocationStart) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        gc.on('trackuserlocationend', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onTrackUserLocationEnd) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        return gc;
    }, { position: props.position });
    thisRef.current.props = props;
    (0, react_1.useImperativeHandle)(ref, function () { return ({
        trigger: function () { return ctrl.trigger(); }
    }); }, []);
    return null;
});
GeolocateControl.displayName = 'GeolocateControl';
exports.default = React.memo(GeolocateControl);
//# sourceMappingURL=geolocate-control.js.map