"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
/* global document */
var React = require("react");
var react_dom_1 = require("react-dom");
var react_1 = require("react");
var mapboxgl_1 = require("../utils/mapboxgl");
var map_1 = require("./map");
var deep_equal_1 = require("../utils/deep-equal");
function Popup(props) {
    var map = (0, react_1.useContext)(map_1.MapContext);
    var container = (0, react_1.useState)(function () {
        return document.createElement('div');
    })[0];
    var popup = (0, react_1.useState)(function () {
        var options = __assign({}, props);
        return new mapboxgl_1.default.Popup(options)
            .setLngLat([props.longitude, props.latitude])
            .setDOMContent(container)
            .addTo(map);
    })[0];
    var thisRef = (0, react_1.useRef)({ props: props });
    thisRef.current.props = props;
    (0, react_1.useEffect)(function () {
        popup.on('open', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onOpen) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        popup.on('close', function (e) {
            var _a, _b;
            (_b = (_a = thisRef.current.props).onClose) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        });
        return function () {
            popup.remove();
        };
    }, []);
    if (popup.getLngLat().lng !== props.longitude || popup.getLngLat().lat !== props.latitude) {
        popup.setLngLat([props.longitude, props.latitude]);
    }
    // @ts-ignore
    if (props.offset && (0, deep_equal_1.deepEqual)(popup.options.offset, props.offset)) {
        popup.setOffset(props.offset);
    }
    // @ts-ignore
    if (popup.options.anchor !== props.anchor || popup.options.maxWidth !== props.maxWidth) {
        // @ts-ignore
        popup.options.anchor = props.anchor;
        popup.setMaxWidth(props.maxWidth);
    }
    // Adapted from https://github.com/mapbox/mapbox-gl-js/blob/main/src/ui/popup.js
    // @ts-ignore
    if (popup.options.className !== props.className) {
        // @ts-ignore
        popup.options.className = props.className;
        // @ts-ignore
        popup._classList = new Set(props.className ? props.className.trim().split(/\s+/) : []);
        // @ts-ignore
        popup._updateClassList();
    }
    return (0, react_dom_1.createPortal)(props.children, container);
}
// @ts-ignore
exports.default = React.memo(Popup);
//# sourceMappingURL=popup.js.map