"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMap = exports.MapProvider = exports.MountedMapsContext = void 0;
var React = require("react");
var react_1 = require("react");
exports.MountedMapsContext = React.createContext(null);
var MapProvider = function (props) {
    var _a = (0, react_1.useState)({}), maps = _a[0], setMaps = _a[1];
    var onMapMount = (0, react_1.useCallback)(function (map, id) {
        var _a;
        if (id === void 0) { id = 'default'; }
        if (maps[id]) {
            throw new Error("Multiple maps with the same id: ".concat(id));
        }
        setMaps(__assign(__assign({}, maps), (_a = {}, _a[id] = map, _a)));
    }, [maps]);
    var onMapUnmount = (0, react_1.useCallback)(function (id) {
        if (id === void 0) { id = 'default'; }
        var nextMaps = __assign({}, maps);
        delete nextMaps[id];
        setMaps(nextMaps);
    }, [maps]);
    return (React.createElement(exports.MountedMapsContext.Provider, { value: {
            maps: maps,
            onMapMount: onMapMount,
            onMapUnmount: onMapUnmount
        } }, props.children));
};
exports.MapProvider = MapProvider;
function useMap() {
    var maps = (0, react_1.useContext)(exports.MountedMapsContext).maps;
    return maps;
}
exports.useMap = useMap;
//# sourceMappingURL=use-map.js.map