/// <reference types="mapbox-gl" />
import type { MapboxMap, ViewState } from '../types';
import type Mapbox from './mapbox';
/** mapboxgl.Map methods to forward to the ref object
    Object.getOwnPropertyNames(Object.getPrototypeOf(map))
      .filter(key => typeof temp1[key] === 'function' && key[0] != '_')
  */
declare const forwardMethods: readonly ["panBy", "panTo", "zoomTo", "zoomIn", "zoomOut", "rotateTo", "resetNorth", "resetNorthPitch", "snapToNorth", "cameraForBounds", "fitBounds", "fitScreenCoordinates", "jumpTo", "getFreeCameraOptions", "setFreeCameraOptions", "easeTo", "flyTo", "isEasing", "stop", "getContainer", "getCanvasContainer", "getCanvas", "resize", "getBounds", "project", "unproject", "isMoving", "isZooming", "isRotating", "on", "once", "off", "queryRenderedFeatures", "querySourceFeatures", "queryTerrainElevation", "isStyleLoaded", "isSourceLoaded", "areTilesLoaded", "getSource", "addImage", "updateImage", "hasImage", "removeImage", "loadImage", "listImages", "moveLayer", "getLayer", "setLight", "getLight", "setTerrain", "getTerrain", "setFog", "getFog", "setFeatureState", "removeFeatureState", "getFeatureState", "loaded"];
export declare type MapRef = {
    getMap(): MapboxMap;
    getViewState(): ViewState;
} & Pick<MapboxMap, typeof forwardMethods[number]>;
export default function createRef(mapInstance: Mapbox): MapRef;
export {};
