"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** mapboxgl.Map methods to forward to the ref object
    Object.getOwnPropertyNames(Object.getPrototypeOf(map))
      .filter(key => typeof temp1[key] === 'function' && key[0] != '_')
  */
var forwardMethods = [
    // 'getCenter',
    // 'setCenter',
    'panBy',
    'panTo',
    // 'getZoom',
    // 'setZoom',
    'zoomTo',
    'zoomIn',
    'zoomOut',
    // 'getBearing',
    // 'setBearing',
    // 'getPadding',
    // 'setPadding',
    'rotateTo',
    'resetNorth',
    'resetNorthPitch',
    'snapToNorth',
    // 'getPitch',
    // 'setPitch',
    'cameraForBounds',
    'fitBounds',
    'fitScreenCoordinates',
    'jumpTo',
    'getFreeCameraOptions',
    'setFreeCameraOptions',
    'easeTo',
    'flyTo',
    'isEasing',
    'stop',
    // "addControl",
    // "removeControl",
    // "hasControl",
    'getContainer',
    'getCanvasContainer',
    'getCanvas',
    'resize',
    'getBounds',
    // "getMaxBounds",
    // "setMaxBounds",
    // "setMinZoom",
    // "getMinZoom",
    // "setMaxZoom",
    // "getMaxZoom",
    // "setMinPitch",
    // "getMinPitch",
    // "setMaxPitch",
    // "getMaxPitch",
    // "getRenderWorldCopies",
    // "setRenderWorldCopies",
    // "getProjection",
    // "setProjection",
    'project',
    'unproject',
    'isMoving',
    'isZooming',
    'isRotating',
    'on',
    'once',
    'off',
    'queryRenderedFeatures',
    'querySourceFeatures',
    'queryTerrainElevation',
    // "setStyle",
    // "getStyle",
    'isStyleLoaded',
    // "addSource",
    'isSourceLoaded',
    'areTilesLoaded',
    // "addSourceType",
    // "removeSource",
    'getSource',
    'addImage',
    'updateImage',
    'hasImage',
    'removeImage',
    'loadImage',
    'listImages',
    // "addLayer",
    'moveLayer',
    // "removeLayer",
    'getLayer',
    // "setLayerZoomRange",
    // "setFilter",
    // "getFilter",
    // "setPaintProperty",
    // "getPaintProperty",
    // "setLayoutProperty",
    // "getLayoutProperty",
    'setLight',
    'getLight',
    'setTerrain',
    'getTerrain',
    'setFog',
    'getFog',
    'setFeatureState',
    'removeFeatureState',
    'getFeatureState',
    'loaded'
    // "remove",
    // "triggerRepaint"
];
function createRef(mapInstance) {
    if (!mapInstance) {
        return null;
    }
    var result = {
        getMap: function () { return mapInstance.map; },
        getViewState: function () { return mapInstance.viewState; }
    };
    for (var _i = 0, forwardMethods_1 = forwardMethods; _i < forwardMethods_1.length; _i++) {
        var key = forwardMethods_1[_i];
        result[key] = mapInstance.map[key].bind(mapInstance.map);
    }
    return result;
}
exports.default = createRef;
//# sourceMappingURL=create-ref.js.map