import { useContext, useState, useEffect } from 'react';
import { MapContext } from './map';
export default function useControl(onCreate, opts) {
    const map = useContext(MapContext);
    const [ctrl] = useState(onCreate());
    useEffect(() => {
        if (map) {
            map.addControl(ctrl, opts?.position);
            opts?.onAdd?.(map);
            return () => {
                opts?.onRemove?.(map);
                map.removeControl(ctrl);
            };
        }
        return undefined;
    }, [map]);
    return ctrl;
}
//# sourceMappingURL=use-control.js.map